FA.JustBlog/FA.JustBlog.Web/Areas/Admin/Controllers/CommentsController.cs
using FA.JustBlog.Common;
using FA.JustBlog.Core.Infrastructures;
using FA.JustBlog.Core.Models;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;

namespace FA.JustBlog.Web.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Authorize(Roles = SD.Role_Blog_Owner + "," + SD.Role_Contributor)]
    public class CommentsController : Controller
    {
        private readonly IUnitOfWork _unitOfWork;

        public CommentsController(IUnitOfWork unitOfWork)
        {
            _unitOfWork = unitOfWork;
        }

        public IActionResult Index()
        {

            return View();
        }

        //GET
        public IActionResult Create()
        {
            ViewBag.PostList = _unitOfWork.PostRepository.GetAll().Select(i => new SelectListItem
            {
                Text = i.Title,
                Value = i.Id.ToString()
            });
            return View();
        }

        //Comment
        [HttpPost]
        [ValidateAntiForgeryToken]
        public IActionResult Create(Comment request)
        {

            if (ModelState.IsValid)
            {
                this._unitOfWork.CommentRepository.Add(request);
                _unitOfWork.SaveChange();
                TempData["success"] = "Comment created successfully";
                return RedirectToAction("Index");
            }
            TempData["error"] = "Comment created error";
            return View(request);
        }

        //GET
        public IActionResult Edit(int? id)
        {

            if (id.Value == null || id.Value == 0)
            {
                return NotFound();
            }
            var CommentFromDbFirst = _unitOfWork.CommentRepository.GetById(id.Value);
            if (CommentFromDbFirst == null)
            {
                return NotFound();
            }

            return View(CommentFromDbFirst);
        }

        //Comment
        [HttpPost]
        [ValidateAntiForgeryToken]
        public IActionResult Edit(Comment obj)
        {

            if (ModelState.IsValid)
            {
                _unitOfWork.CommentRepository.Update(obj);
                _unitOfWork.SaveChange();
                TempData["success"] = "Comment updated successfully";
                return RedirectToAction("Index");
            }
            TempData["error"] = "Comment created error";
            return View(obj);
        }


        #region API CALLS
        [HttpGet]
        public IActionResult GetAll(string status)
        {
            var productList = _unitOfWork.CommentRepository.GetAll(includeProperties:"Post");
            return Json(new { data = productList });
        }

        //Comment
        [HttpDelete]
        [Authorize(Roles = SD.Role_Blog_Owner)]
        public IActionResult Delete(int? id)
        {
            var obj = _unitOfWork.CommentRepository.GetById(id.Value);
            if (obj == null)
            {
                return Json(new { success = false, message = "Error while deleting" });
            }
            _unitOfWork.CommentRepository.Delete(obj);
            _unitOfWork.SaveChange();
            return Json(new { success = true, message = "Delete Successful" });

        }
        #endregion

    }
}

FA.JustBlog/FA.JustBlog.Web/Areas/Admin/Views/Comments/Create.cshtml
@model Comment
@{
    ViewData["Title"] = "Create";
    Layout = "~/Views/Shared/_LayoutAdmin.cshtml";
}

<form method="post"  asp-action="Create" style="width:90%; margin: 0 auto;" enctype="multipart/form-data">
	<div class="border p-3 mt-4" >
		<div class="row pb-6">
			<h2 class="text-primary">Create Comment</h2>
			<hr />
		</div>
		<div class="mb-3">
			<label asp-for="Name"></label>
			<input asp-for="Name" class="form-control" onchange="myFunction()" />
			<span asp-validation-for="Name" class="text-danger"></span>
		</div>

		<div class="mb-3">
			<label asp-for="Email"></label>
			<textarea asp-for="Email" rows="3" class="form-control"></textarea>
			<span asp-validation-for="Email" class="text-danger"></span>
		</div>
		<div class="mb-3">
			<label asp-for="CommentHeader"></label>
			<textarea asp-for="CommentHeader" rows="3" class="form-control"></textarea>
			<span asp-validation-for="CommentHeader" class="text-danger"></span>
		</div>
		<div class="mb-3">
			<label asp-for="PostId">Post Name</label>
			<select asp-for="PostId" asp-items="@ViewBag.PostList" class="form-control">
				<option disabled selected>--Select CoverType--</option>
			</select>
			<span asp-validation-for="PostId" class="text-danger"></span>
		</div>
		<button type="submit" class="btn btn-primary" style="width:150px">Create</button>
		<a asp-controller="Comments" asp-action="Index" class="btn btn-secondary" style="width:150px">
			Back to List
		</a>
	</div>
</form>

@section Scripts{
	@{
		<partial name="_ValidationScriptsPartial" />
	}
		<script>
		tinymce.init({
		  selector: 'textarea',
		  plugins: 'advlist autolink lists link image charmap print preview hr anchor pagebreak',
		  toolbar_mode: 'floating',
	   });

		function ValidateInput(){
			if(document.getElementById("uploadBox").value==""){
				Swal.fire({
				  icon: 'error',
				  title: 'Oops...',
				  text: 'Please upload an Image!',
				});
				return false;
			}
			return true;
		}
	</script>
}

FA.JustBlog/FA.JustBlog.Web/Areas/Admin/Views/Comments/Index.cshtml
@{
    ViewData["Title"] = "Index";
}
    <div class="container p-3">
        <div class="row pt-4">
            <div class="col-6">
                <h2 class="text-primary">Comment List</h2>
            </div>
            <div class="col-6 text-end">
                <a asp-controller="Comments" asp-action="Create" class="btn btn-primary">
                    <i class="bi bi-plus-circle"></i> &nbsp; Create New Comment
                </a>
            </div>
        </div>
        <br /><br />

        <table id="tblData" class="table table-bPostsed table-striped" style="width:100%">
            <thead>
                <tr>
                    <th>Id</th>
                    <th>Name</th>
                    <th>Email</th>
                    <th>CommentHeader</th>
                    <th>Post Id</th>
                    <th></th>
                </tr>
            </thead>
        </table>
    </div>

@section scripts{
    <script src="~/js/comment.js"></script>
}